////////////////////////////////////////////////////////////////////////////////
//
// Paella
// Copyright (C) 2015 - Thomas FORGIONE, Emilie JALRAS, Marion LENFANT, Thierry MALON, Amandine PAILLOUX
// Authors :
//     Thomas FORGIONE
//     Emilie JALRAS
//     Marion LENFANT
//     Thierry MALON
//     Amandine PAILLOUX
//
// This file is part of the project Paella
// This software is provided 'as-is', without any express or implied warranty.
// In no event will the authors be held liable for any damages arising from the use of this software.
//
// Permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it freely,
// subject to the following restrictions:
//
// 1. The origin of this software must not be misrepresented;
//    you must not claim that you wrote the original software.
//    If you use this software in a product, an acknowledgment
//    in the product documentation would be appreciated but is not required.
//
// 2. Altered source versions must be plainly marked as such,
//    and must not be misrepresented as being the original software.
//
// 3. This notice may not be removed or altered from any source distribution.
////////////////////////////////////////////////////////////////////////////////
#ifndef CIRCLE_HPP
#define CIRCLE_HPP

#include <vector>
#include <utility>
#include <Geometry/Vector.hpp>

namespace geo
{

///////////////////////////////////////////////////////////////
/// \brief Utility template class for manipulating 3D discrete circles
///////////////////////////////////////////////////////////////
template<typename T>
class Circle
{
    public:
        //////////////////////////////////////////////////////////////////
        /// \brief Default constructor
        ///
        /// Initialize all arrays
        //////////////////////////////////////////////////////////////////
        Circle() : center{}, points{} {};

        geo::Vector3<T> center; ///< Center of the circle
        std::vector<std::pair<unsigned int, geo::Vector3<T>>> points; ///< Some points on the circle
};
}

#endif // CIRCLE_HPP



