////////////////////////////////////////////////////////////////////////////////
//
// Paella
// Copyright (C) 2015 - Thomas FORGIONE, Emilie JALRAS, Marion LENFANT, Thierry MALON, Amandine PAILLOUX
// Authors :
//     Thomas FORGIONE
//     Emilie JALRAS
//     Marion LENFANT
//     Thierry MALON
//     Amandine PAILLOUX
//
// This file is part of the project Paella
// This software is provided 'as-is', without any express or implied warranty.
// In no event will the authors be held liable for any damages arising from the use of this software.
//
// Permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it freely,
// subject to the following restrictions:
//
// 1. The origin of this software must not be misrepresented;
//    you must not claim that you wrote the original software.
//    If you use this software in a product, an acknowledgment
//    in the product documentation would be appreciated but is not required.
//
// 2. Altered source versions must be plainly marked as such,
//    and must not be misrepresented as being the original software.
//
// 3. This notice may not be removed or altered from any source distribution.
////////////////////////////////////////////////////////////////////////////////
#ifndef MESHING_HPP
#define MESHING_HPP

//////////////////////////////////////////////////
/// \defgroup meshing Meshing module
///
/// Contains the function and classes to mesh 3D skeletons
///
/// This modules contains a few binaries :
///   - MainDisplay
///   - TestJunction3
///   - TestJunction4
///
/// \section maindisplay MainDisplay
/// This program simply loads a .skl file and display it with
/// OpenGL. You should call the program like so
/// \code
/// bin/MainDisplay <path_to_skl_file>
/// \endcode
///
/// \section testjunction TestJunction
/// This program simply computes the result of the junctions on three circles.
/// TestJunction3 computes a junction from three circles and
/// TestJunction4 computes it from four.
//////////////////////////////////////////////////

#include <Meshing/Skeleton3D.hpp>

#endif // MESHING_HPP
