////////////////////////////////////////////////////////////////////////////////
//
// Paella
// Copyright (C) 2015 - Thomas FORGIONE, Emilie JALRAS, Marion LENFANT, Thierry MALON, Amandine PAILLOUX
// Authors :
//     Thomas FORGIONE
//     Emilie JALRAS
//     Marion LENFANT
//     Thierry MALON
//     Amandine PAILLOUX
//
// This file is part of the project Paella
// This software is provided 'as-is', without any express or implied warranty.
// In no event will the authors be held liable for any damages arising from the use of this software.
//
// Permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it freely,
// subject to the following restrictions:
//
// 1. The origin of this software must not be misrepresented;
//    you must not claim that you wrote the original software.
//    If you use this software in a product, an acknowledgment
//    in the product documentation would be appreciated but is not required.
//
// 2. Altered source versions must be plainly marked as such,
//    and must not be misrepresented as being the original software.
//
// 3. This notice may not be removed or altered from any source distribution.
////////////////////////////////////////////////////////////////////////////////
#include <opencv2/highgui/highgui.hpp>
#include <opencv2/imgproc/imgproc.hpp>

#ifdef _WIN32
    #define CV_ESCAPE 27
#else
    #define CV_ESCAPE 1048603
#endif

#include <iostream>

int main()
{
    cv::VideoCapture cap(0);   //0 is the id of video device.0 if you have only one camera.
    cap.set(CV_CAP_PROP_FRAME_WIDTH, 1920);
    cap.set(CV_CAP_PROP_FRAME_HEIGHT, 1080);

    // Create the window
    cv::namedWindow( "Display window", cv::WINDOW_AUTOSIZE );
    cv::setWindowProperty("Display window", CV_WINDOW_FULLSCREEN, CV_WINDOW_FULLSCREEN);

    if (!cap.isOpened())
    {
        //check if video device has been initialised
        std::cout << "cannot open camera" << std::endl;
    }

    std::cout << "Let's go ..." << std::endl;

    cv::Mat cameraFrame;
    int wait = 0;

    while (true)
    {
        cap >> cameraFrame;
        cv::flip(cameraFrame,cameraFrame,1);
        cv::imshow("Display window", cameraFrame);

        wait = cv::waitKey(20);

        if (wait == CV_ESCAPE) // Escape
            break;

    }

    return 0;
}
